
INFTY = 100000000
#Znalezienie ścieżek z użyciem algorytmu BFS
def bfs(C, F, s, t):
        kolejka = [s]
        sciezki = {s:[]}
        if s == t:
            return sciezki[s]
        while kolejka: 
            u = kolejka.pop(0)
            for v in range(len(C)):
                    if(C[u][v]-F[u][v]>0) and v not in sciezki:
                        sciezki[v] = sciezki[u] + [(u,v)]
                        if v == t:
                            return sciezki[v]
                        kolejka.append(v)
        return None

#Algorytm Forda-Fulkersona w wersji Edmondsa-Karpa
def Edmonds_Karp(C, s, F):
        n = len(C)
        t = n-1
        sciezka = bfs(C, F, s, t)
        while sciezka != None:
            przeplyw = min(C[u][v] - F[u][v] for u,v in sciezka)
            for u,v in sciezka:
                F[u][v] += przeplyw
                F[v][u] -= przeplyw
            sciezka = bfs(C, F, s, t)
        return sum(F[s][i] for i in range(n))
  
def read_graph(n,m,s):
    C = [[0 for qqq in range(n+1)] for _ in range(n+1)]
    for i in range(m-1):
        edge = list(map(int, input().split()))
#        print(edge)
        C[edge[0]][edge[1]] = edge[2]
    for i in range(1,s+1):
        C[0][i] = INFTY 
    return C

DEBUG = False
DEBUG2 = False

#Wczytujemy parametry zadania
config = list(map(int, input().split()))
#Wczytujemy graf do postaci macierzowej
C = read_graph(config[0],config[1],config[2])
#Początkowe wartości przepływów między wierzchołkami ustawiamy na zero
F = [[0] * (config[0]+1) for i in range(config[0]+1)]
#Wczytujemy interesującą nas krawędź:
missing_edge = list(map(int, input().split()))
#Jeżeli możemy zwiększać w nieskończoność krawędź łączącą któreś ze źródeł z wyjściem
# to mamy problem...
if(missing_edge[0]<=config[2] and missing_edge[1] == config[0]):
    print("BAJTRYK ZWYCIEZYL HAHAHAHA")
else:
    #obliczamy max_flow bez brakującej krawędzi
    initial_flow = Edmonds_Karp(C,0,F)
    #obliczamy max_flow z brakującą krawędzią (pozwalamy jej na dowolnie duży przepływ)
    C[missing_edge[0]][missing_edge[1]] = INFTY
    after_flow = Edmonds_Karp(C, 0, F)
    if(DEBUG):
        for row in C:
            print(row)
    if(F[missing_edge[0]][missing_edge[1]] != after_flow-initial_flow):
        print("MAMY PROBLEM")
    print(initial_flow, after_flow-initial_flow, sep=' ')
